unit uTest2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeEdit, ExtCtrls, TeeProcs, TeEngine, Chart, Series, CurvFitt;

type
  TResTime = class(TForm)
    Chart1: TChart;
    ChartEditor1: TChartEditor;
    serLowerBound: TPointSeries;
    serUpperBound: TPointSeries;
    TTeeFunction1: TCurveFittingFunction;
    RtLabData: TPointSeries;
    serFit: TFastLineSeries;
    serSmoothFit: TFastLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ResTime: TResTime;

implementation

uses math;

{$R *.dfm}


procedure PlotSmoothFit( var serFit, serSmoothFit : tFastLineSeries;
                         FitFctn : TCurveFittingFunction;
                         smoothness : integer );

var interval, x, y : double; i, imax : integer; coeffs : array of double;

begin
  with FitFctn do begin
    imax := polydegree;
    SetLength( coeffs, imax );
    for i := 1 to imax do
      coeffs[ i-1 ] := AnswerVector[ i ];
    { end }
  end;
  with serFit do begin
    interval := ( maxXvalue - minXvalue )/ Smoothness;
    for i := 1 to Smoothness do begin
      x := minXvalue + (i-1) * interval;
      y := poly( x-minXvalue, coeffs ) + minYvalue;
      serSmoothFit.AddXY( x, y )
    end;
  end
end;

procedure TResTime.FormCreate(Sender: TObject);
begin
  with RtLabData do begin
    AddXY( 5.005E+02, 5.86E+03 );
    AddXY( 6.665E+02, 4.00E+03 );
    AddXY( 8.366E+02, 2.98E+03 );
    AddXY( 9.530E+02, 2.62E+03 );
    AddXY( 1.325E+03, 1.79E+03 );
  end;
  tTeeFunction1.PolyDegree := 4;
  tTeeFunction1.AddPoints( RtLabData );
  PlotSmoothFit( serFit, serSmoothFit, tTeeFunction1, 500 );
end;

procedure TResTime.Chart1DblClick(Sender: TObject);
begin
  ChartEditor1.Execute
end;

end.
